<?php
/**
 * Faboba News System 
 * Joomla! 1.5 component fanews
 * @author	Stphane Bouey {@link http://www.faboba.com}
 * @package Joomla
 * @subpackage Fanews
 * @license GNU/GPL
 * @Copyright (C) 2010 Faboba.com
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class FanewsModelNews extends JModel {

    /**
     * Constructor that retrieves the ID from the request
     *
     * @access	public
     * @return	void
     */
        function __construct() {
            parent::__construct();

            $array = JRequest::getVar('cid',  0, '', 'array');
            $this->setId((int)$array[0]);
        }//function

        /**
         *
         * @access	public
         * @param	int fanews identifier
         * @return	void
         */
        function setId($id) {
        // Set id and wipe data
            $this->_id		= $id;
            $this->_data	= null;
        }//function

        function getList() {
            if (empty($this->_data)) {
                $db = JFactory::getDBO();

                ## Making the query for showing all the cars in list function
                $sql = "SELECT * FROM #__fanews";

                $db->setQuery($sql);
                $this->data = $db->loadObjectList();
            }
            return $this->data;
        }

        /**
         * Method to get a record
         * @return object with data
         */
        function &getData() {
        // Load the data
            if (empty( $this->_data )) {
                $query = ' SELECT * FROM #__fanews'.
                    '  WHERE id = '.$this->_id;
                $this->_db->setQuery( $query );
                $this->_data = $this->_db->loadObject();
            }
            if (!$this->_data) {
                $this->_data = new stdClass();
                $this->_data->id = 0;
                $this->_data->name = null;
            }
            return $this->_data;
        }//function

        /**
         * Method to store a record
         *
         * @access	public
         * @return	boolean	True on success
         */
        function store() {
            $row    = & $this->getTable();
            $user   = & JFactory::getUser();


            $data = JRequest::get( 'post' );
            /* Get proper HTML-code for your HTML-encoded field now by using JREQUEST_ALLOWHTML*/
            /* bug in the JREQUEST_ALLOWHTML you must use JREQUEST_ALLOWRAW */
            $data['fulltext']=JRequest::getVar( 'fulltext', '', 'post', 'string', JREQUEST_ALLOWRAW );
            // Bind the form fields to the hello table
            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }

            // Are we saving from an item edit?
            if ($row->id) {
                $row->modified 		= gmdate('Y-m-d H:i:s');
                $row->modified_by 	= $user->get('id');
            } else {
                $row->modified 		= $nullDate;
                $row->modified_by 	= '';
                $row->created           = gmdate('Y-m-d H:i:s');
                $row->created_by	= $user->get('id');
            }
            
            // Make sure the record is valid
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }

            // Store the table to the database
            if (!$row->store()) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }

            return true;
        }//function

        /**
         * Method to delete record(s)
         *
         * @access	public
         * @return	boolean	True on success
         */
        function delete() {
            $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

            $row =& $this->getTable();

            if (count( $cids )) {
                foreach($cids as $cid) {
                    if (!$row->delete( $cid )) {
                        $this->setError( $row->getErrorMsg() );
                        return false;
                    }
            }//foreach
            }
            return true;
    }//function

}// class

?>